; TW.ASM
;
; James K. Lawless
; 2414 4th Ave
; Council Bluffs, IA 51501
; 74217.531@compuserve.com
; Assemble/Link (Turbo Assembler):
;   tasm tw
;   tlink /t tw
;

code        segment
        assume  cs:code,ds:code
main        proc    far
        org 100h
begin:

; Install the TSR
        jmp install

tsr_inf     struc
next        dd  ?   ; next TSR Info link
psp         dw  ?   ; TSR's PSP
ver         dw  0100h   ; version. 
exec        dw  1   ; 1=load EXE
show        dw  1
cmd         dd  ?
rsvd        dd  0
id          dd  0
t_data      dd  0
tsr_inf     ends


write       tsr_inf <>
notepad     tsr_inf <>


write_name  db  "WRITE.EXE",0
notepad_name    db  "NOTEPAD.EXE",0


old_int_2f  dd  ?

new_int_2f:
; If it's not for us, chain to the next 2Fh handler
        cmp ax,160bh
        jz  ni2_more
        jmp cs:[old_int_2f]
ni2_more:
; take pointer passed to us and store in our last link
        mov word ptr cs:[notepad.next],di
        mov word ptr cs:[notepad.next],es

; pass on our topmost link to the next process in the
; INT 2Fh chain.
        push    cs
        pop es
        mov di,offset write
        jmp cs:[old_int_2f]
install:
        push    cs
        pop ds

; CS is PSP for a COM file
        mov notepad.psp,cs
        mov write.psp,cs

; point the "write" structure's next-link to
; the address of the notepad structure
        mov word ptr write.next+2,cs
        mov word ptr write.next,offset notepad

; point each structure's EXE file name to the appropriate
; spot
        mov word ptr write.cmd+2,cs
        mov word ptr write.cmd,offset write_name

        mov word ptr notepad.cmd+2,cs
        mov word ptr notepad.cmd,offset notepad_name

; Get the interrupt vector for INT 2fh
        mov ax,352fh
        int 21h
; Save it 
        mov word ptr [old_int_2f],bx
        mov word ptr [old_int_2f+2],es

; Set INT 2Fh to our new vector
        mov dx,offset new_int_2f
        mov ax,252fh
        int 21h

; Terminate and stay resident
        mov dx,offset install
        shr dx,1
        shr dx,1
        shr dx,1
        shr dx,1
        inc dx
        mov ax,3100h
        int 21h
        
main        endp
code        ends
        end begin
